	INCLUDE EFR32MG12.inc			; CPU register definitions	
		
	AREA    |.text|, CODE, READONLY	; another section in the CODE area	
;-------------------------------------------------------------------------------
GPIO_setup	PROC				; I/O Ports configuration
	EXPORT	GPIO_setup
	OORW	1<<3, CMU_HFBUSCLKEN0, CMU	; enable clock to GPIO
	OORW	4, GPIO_PD_MODEH, GPIO		; configure PD.8 for digital output	
	bx	LR
	ENDP	

;-------------------------------------------------------------------------------
LETIMER_setup	PROC
	EXPORT	LETIMER_setup
	PUTW	1, CMU_LFACLKEN0, CMU		; enable LFA clock for LETIMER
	PUTW	1<<9, LETIMERn_CTRL, LETIMER0	; set period	
	PUTW	3276, LETIMERn_COMP0		; 0.1 sec period
	PUTW	0x1F, LETIMERn_IFC		; clear all IF	
	PUTW	5, LETIMERn_CMD, LETIMER0	; start timer
	PUTW	4, LETIMERn_IEN			; enable posting UF flag to NVIC
	OORW	1<<27, 0, NVIC_ISER0		; enable LETIMER0 interrupts in NVIC
	bx	LR
	ENDP

;-------------------------------------------------------------------------------
SPI3_setup	PROC
	EXPORT	SPI3_setup
	OORW	1<<7, CMU_HFPERCLKEN0, CMU	; enable clock to USART3	
	OORW	0x4414, GPIO_PC_MODEL, GPIO	; configure PC.0-3 
	OORW	1<<3, GPIO_PC_DOUT		; CS up
	PUTW	(1<<12)+(1<<10)+1, USARTn_CTRL, USART3	; use sync mode, msb first
	PUTW	0x88<<4, USARTn_CLKDIV			; set 1mbps speed
	PUTW	(18<<24)+(18<<8)+18, USARTn_ROUTELOC0   ; use location 18 for SPI pins
	PUTW	0x0B, USARTn_ROUTEPEN			; enable TX, RX, CLK pins
	PUTW	0xE15, USARTn_CMD			; enable SPI
	bx	LR
	ENDP

	ALIGN
	END
	