	INCLUDE EFR32MG12.inc			; CPU register definitions	
	IMPORT	SPIMasterReadBuf
	IMPORT	SPIMasterWriteBuf
	IMPORT	SPIbuf
	IMPORT	Xacc	

	AREA    |.text|, CODE, READONLY	; another section in the CODE area
ICM20648_setup	PROC
	EXPORT	ICM20648_setup
	push	{LR, R0-R2}	
	OORW	0x04, GPIO_PF_MODEH, GPIO		
	OORW	1<<8, GPIO_PF_DOUT		; power-up the sensor	

	ldr	R0, =1000000			; power-up delay
isd	subs	R0, #1
	bne	isd

	ldr	R0, =SPIbuf
	mov	R1, #3
	mov	R2, #5
	bl	SPIMasterReadBuf
	
	PUTB	0x30, 0, SPIbuf			; ODR operation
	PUTB	0x9, 1				; disable temp
	PUTB	0x7, 2				; disable gyro
	
	ldr	R0, =SPIbuf
	mov	R1, #3				; write 1 byte to reg 6
	mov	R2, #5
	bl	SPIMasterWriteBuf

	ldr	R0, =SPIbuf
	mov	R1, #3
	mov	R2, #5
	bl	SPIMasterReadBuf

isde	pop	{PC, R0-R2}
	ENDP

;----------------------------------------------------------
ICM20648_read_ACC	PROC
	EXPORT	ICM20648_read_ACC
	push	{LR, R0-R2}	
	ldr	R0, =Xacc
	mov	R1, #6				; read 6 bytes
	mov	R2, #0x2D			; ACCEL_XOUT_H reg	
	bl	SPIMasterReadBuf		; read data
	
	ldrh	R1, [R0]			; reverse bytes order
	rev16	R1, R1
	strh	R1, [R0]
	ldrh	R1, [R0, #2]
	rev16	R1, R1
	strh	R1, [R0, #2]
	ldrh	R1, [R0, #4]
	rev16	R1, R1
	strh	R1, [R0, #4]
	pop	{PC, R0-R2}
	ENDP

	ALIGN
	END	