	INCLUDE EFR32MG12.inc			; CPU register definitions	

CS_C	EQU	1<<3				; CS at PC3
CS_A	EQU	1<<5				; CS at PA5

	
;-------------------------------------	; non-initialized DATA segment in RAM 
	AREA	RAM, DATA, NOINIT, READWRITE, ALIGN=3
SPIbuf	SPACE	32	
	EXPORT	SPIbuf
		
		
	AREA    |.text|, CODE, READONLY	; another section in the CODE area
SPIMasterWriteBuf	PROC
	EXPORT	SPIMasterWriteBuf		; R0=buffer, R1=length R2=register
	push	{LR, R0-R4}
	bl	CS_C_down

	ldr	R3, =USART3
swb1	ldr	R4, [R3, #USARTn_IF]		; wait for TXBL flag
	ands	R4, #0x02
	beq	swb1
	strb	R2, [R3, #USARTn_TXDATA]	; send reg address
	
swb2	cbz	R1, swb4			; all bytes sent?	
swb3	ldr	R4, [R3, #USARTn_IF]		; wait for end of transmission
	ands	R4, #0x04
	beq	swb3
	ldrb	R2, [R3, #USARTn_RXDATA]	; read fake byte
	ldrb	R2, [R0], #1			; get next byte to send
	strb	R2, [R3, #USARTn_TXDATA]	; send byte	
	sub	R1, #1
	b	swb2

swb4	ldrb	R2, [R3, #USARTn_RXDATA]
swb5	ldr	R4, [R3, #USARTn_IF]		; wait for TXBL flag
	ands	R4, #0x04			; wait for end of transmission
	beq	swb5
	ldrb	R2, [R3, #USARTn_RXDATA]	; read fake byte
	
	bl	CS_C_up
	pop	{PC, R0-R4}
	ENDP
		
;------------------------------------------------------------------
SPIMasterReadBuf	PROC			; R0=buffer, R1=length R2=register
	EXPORT	SPIMasterReadBuf
	push	{LR, R0-R4}
	bl	CS_C_down
	
	ldr	R3, =USART3
srb1	ldr	R4, [R3, #USARTn_IF]		; wait for TXBL flag
	ands	R4, #0x02
	beq	srb1
	orr	R2, #0x80			; read reg
	strb	R2, [R3, #USARTn_TXDATA]	; send reg address

srb2	ldr	R4, [R3, #USARTn_IF]		; wait for end of transmission
	ands	R4, #0x04
	beq	srb2
	ldrb	R2, [R3, #USARTn_RXDATA]	; read fake byte

srb3	cbz	R1, srb5			; all bytes received?
	strb	R2, [R3, #USARTn_TXDATA]	; No - receive next byte
srb4	ldr	R4, [R3, #USARTn_IF]		; wait for RXDATAV flag
	ands	R4, #0x04
	beq	srb4
	ldrb	R2, [R3, #USARTn_RXDATA]	; get received byte
	strb	R2, [R0], #1			; save received byte
	sub	R1, #1
	b	srb3
		
srb5	bl	CS_C_up	
	pop	{PC, R0-R4}
	ENDP

;-----------------------------------------------------
CS_C_down	PROC
	push	{R3, R4}
	ldr	R3, =GPIO			; CS down
	ldr	R4, [R3, #GPIO_PC_DOUT]
	bic	R4, #CS_C
	str	R4, [R3, #GPIO_PC_DOUT]	
	pop	{R3, R4}
	bx	LR
	ENDP
		
;----------------------------------------------------	
CS_C_up	PROC
	push	{R3, R4}
	ldr	R3, =GPIO			; CS up
	ldr	R4, [R3, #GPIO_PC_DOUT]
	orr	R4, #CS_C
	str	R4, [R3, #GPIO_PC_DOUT]
	pop	{R3, R4}
	bx	LR	
	ENDP
		

	ALIGN	
	END	
	